

-- Run this script to create the Gaixie database tables in your database.

-- *****************************************************
-- Create the tables and indices

-- ------------------------------------------------------
CREATE TABLE userbase (
    id                     integer generated by default as identity(start with 1) NOT NULL PRIMARY KEY,
    username               varchar(255) NOT NULL,    
    password               varchar(128) NOT NULL,
    fullname               varchar(255) NOT NULL,
    emailaddress           varchar(255),
    enabled                bit default 1 NOT NULL
);
ALTER TABLE userbase ADD CONSTRAINT userbase_username_uq UNIQUE ( username );

-- ------------------------------------------------------
CREATE TABLE roles (
    id                     integer generated by default as identity(start with 1) NOT NULL PRIMARY KEY,
    name                   varchar(255) NOT NULL,
    lft                    integer NOT NULL,
    rgt                    integer NOT NULL,
    description            longvarchar NOT NULL
);
ALTER TABLE roles ADD CONSTRAINT roles_name_uq UNIQUE ( name );

insert into roles(name,lft,rgt,description) values ('ROLE_BASE',1,2,'For all logged in users');

-- ------------------------------------------------------
CREATE TABLE user_role_map (
    user_id              integer NOT NULL,
    role_id              integer NOT NULL
);
ALTER TABLE user_role_map ADD CONSTRAINT user_role_map_user_id_uq UNIQUE ( user_id,role_id );
ALTER TABLE user_role_map ADD CONSTRAINT urmap_role_id_fk FOREIGN KEY (role_id) REFERENCES roles (id);
ALTER TABLE user_role_map ADD CONSTRAINT urmap_user_id_fk FOREIGN KEY (user_id) REFERENCES userbase (id);

-- ------------------------------------------------------
CREATE TABLE authorities (
    id                     integer generated by default as identity(start with 1) NOT NULL PRIMARY KEY,
    name                   varchar(255) NOT NULL,
    value                  varchar(255) NOT NULL,
    lft                    integer NOT NULL,
    rgt                    integer NOT NULL
);
ALTER TABLE authorities ADD CONSTRAINT authorities_name_uq UNIQUE ( name );

insert into authorities(name,value,lft,rgt) values ('Gaixie','#',1,2);
-- ------------------------------------------------------
CREATE TABLE role_authority_map (
    role_id                integer NOT NULL,
    authority_id           integer NOT NULL
);
ALTER TABLE role_authority_map ADD CONSTRAINT role_authority_map_role_id_uq UNIQUE ( role_id,authority_id );
ALTER TABLE role_authority_map ADD CONSTRAINT rrmap_role_id_fk FOREIGN KEY (role_id) REFERENCES roles (id);
ALTER TABLE role_authority_map ADD CONSTRAINT rrmap_authority_id_fk FOREIGN KEY (authority_id) REFERENCES authorities (id);
